#include <QtGui>
#include <QtCore>
// #include <QGLWidget>
#include <QtOpenGL>
#include <QIODevice>
#include <math.h>
#include "land3D.h"
// #include <iostream.h>

const static float R=0.75; //   //  
const static float pi=3.141593, k=pi/180; //  
static int iteration_max=1; //   
static float eps=0.00125; //    //  

/* */

Land3D::Land3D(QWidget* pwgt/*= 0*/) : QGLWidget(pwgt), m_xRotate(-90), m_yRotate(0), m_zRotate(0), m_Scale(1)
{ 
//  Land3D      pwgt 
} 

/* */

/*virtual*/void Land3D::initializeGL() 
{

   qglClearColor(Qt::white);         //     
   glEnable(GL_DEPTH_TEST);          //       ?? 
   // glShadeModel(GL_FLAT);            //     
   
   m_nLand3D = createLand3D(1.0f);   //    fSize

}

/* */

/*virtual*/void Land3D::resizeGL(int nWidth, int nHeight) 
{ 
//    glViewport(0, 0, (GLint)nWidth, (GLint)nHeight); //        
   
   glViewport((GLint)nWidth/2-(GLint)nHeight/2, 0, (GLint)nHeight, (GLint)nHeight); //  !!!      !!!
   
   glMatrixMode(GL_PROJECTION);                     //     ( ) ?? 
   glLoadIdentity();                                //      ?? 
                                                    //  
   
   // glFrustum(-0.0, 0.0, -0.0, 0.0, 0.0, 0.0);      //    
   
   //  : (, , , , , )
   
   glOrtho(-1.0, 1.0, -1.0, 1.0, -10.0, 1.0);        //    
}

/* */

/*virtual*/void Land3D::paintGL() 
{ 
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); //   

   glMatrixMode(GL_MODELVIEW);                         //      
   glLoadIdentity();                                   //    
   // glTranslatef(0.0, 0.0, 0.0);                      //     
   
   glRotatef(m_xRotate, 1.0, 0.0, 0.0); 
   glRotatef(m_yRotate, 0.0, 1.0, 0.0); 
   glRotatef(m_zRotate, 0.0, 0.0, 1.0);
   
   glScalef(m_Scale*1.0f, m_Scale*1.0f, m_Scale*1.0f);  
   
   glEnable(GL_CULL_FACE); //      
   
   glCallList(m_nLand3D);  //    glCallList   . 

} 

/* */

/*virtual*/void Land3D::mousePressEvent(QMouseEvent* pe) 
{ 
   m_ptPosition = pe->pos(); //       m_ptPosition  
                             //     
} 

/* */

/*virtual*/void Land3D::mouseMoveEvent(QMouseEvent* pe) 
{
   m_xRotate += 180 * (GLfloat) (pe->y() - m_ptPosition.y()) / height(); //   
   m_zRotate += 180 * (GLfloat) (pe->x() - m_ptPosition.x()) / width(); 
      
   updateGL(); //  
   
   m_ptPosition = pe->pos(); 
}

/* */

/*virtual*/void Land3D::keyPressEvent(QKeyEvent* pe)
{  
   switch (pe -> key())
   {
         case Qt::Key_Up:    m_Scale = m_Scale*1.01;
         break;
         
         case Qt::Key_Down:  m_Scale = m_Scale/1.01;
         break;
         
         case Qt::Key_Left:  m_zRotate += 1.0;
         break;
         
         case Qt::Key_Right: m_zRotate -= 1.0;
         break;
         
         case Qt::Key_Space:  //    
            m_Scale = 1;
            m_xRotate = -90;
            m_yRotate = 0;
            m_zRotate = 0;
         break;
         
   }

   updateGL(); //  
}

/* */

GLuint Land3D::createLand3D(GLfloat fSize/*=1.0f*/) 
{ 
   GLuint n = glGenLists(1); //       
                             //    ??
      
   glNewList(n, GL_COMPILE);    

   //  
   glBegin(GL_LINES);
      glColor4f(0.50f, 0.00f, 0.00f, 1.0f);
      glVertex3f( 0,  0,  1);
      glVertex3f( 0,  0, -1);
   glEnd();     
   
   //  
   glBegin(GL_LINES);
      glColor4f(0.50f, 0.50f, 0.50f, 1.0f);
      glVertex3f( 0,  1,  0);
      glVertex3f( 0, -1,  0);
   glEnd();  
   
   glBegin(GL_LINES);
      glColor4f(0.50f, 0.00f, 0.00f, 1.0f);
      glVertex3f( 1,  0,  0);
      glVertex3f(-1,  0,  0);
   glEnd();
   
   
   QVector<float> Mvertex_Sph; //    
   //     : v[3*i+k]=M[i][k]
   // i -  , k -      
   
   //    !
   
   //         
   QFile file1("ClearMap.map");
   file1.open(QIODevice::ReadOnly);   
   QDataStream in1(&file1);
   in1 >> Mvertex_Sph; // 
   
   iteration_max=Mvertex_Sph[0]; //  
   
   int shft=1; // 
   
   /* ! */
   //   
   Mvertex_Sph[0*3+0+shft]=4;
   Mvertex_Sph[1*3+0+shft]=3;
   Mvertex_Sph[2*3+0+shft]=4; 
   Mvertex_Sph[3*3+0+shft]=7;
   Mvertex_Sph[4*3+0+shft]=4;
   Mvertex_Sph[5*3+0+shft]=3;
   Mvertex_Sph[6*3+0+shft]=3;
   Mvertex_Sph[7*3+0+shft]=3;
   Mvertex_Sph[8*3+0+shft]=3;
   Mvertex_Sph[9*3+0+shft]=3;
   Mvertex_Sph[10*3+0+shft]=4;
   Mvertex_Sph[11*3+0+shft]=4;
   Mvertex_Sph[12*3+0+shft]=4;
   Mvertex_Sph[13*3+0+shft]=3;
   Mvertex_Sph[14*3+0+shft]=3;
   Mvertex_Sph[15*3+0+shft]=4;
   Mvertex_Sph[16*3+0+shft]=2;
   Mvertex_Sph[17*3+0+shft]=3;
   Mvertex_Sph[18*3+0+shft]=3;
   Mvertex_Sph[19*3+0+shft]=2;
   Mvertex_Sph[20*3+0+shft]=3;
   Mvertex_Sph[21*3+0+shft]=3;
   Mvertex_Sph[22*3+0+shft]=3;
   Mvertex_Sph[23*3+0+shft]=3;
   Mvertex_Sph[24*3+0+shft]=4;
   Mvertex_Sph[25*3+0+shft]=5;
   Mvertex_Sph[26*3+0+shft]=3;
   Mvertex_Sph[27*3+0+shft]=2;
   Mvertex_Sph[28*3+0+shft]=2;
   Mvertex_Sph[29*3+0+shft]=3;
   Mvertex_Sph[30*3+0+shft]=3;
   Mvertex_Sph[31*3+0+shft]=2;
   Mvertex_Sph[32*3+0+shft]=2;
   Mvertex_Sph[33*3+0+shft]=2;
   Mvertex_Sph[34*3+0+shft]=2;
   Mvertex_Sph[35*3+0+shft]=1;
   Mvertex_Sph[36*3+0+shft]=2;
   Mvertex_Sph[37*3+0+shft]=3;
   Mvertex_Sph[38*3+0+shft]=2;
   Mvertex_Sph[39*3+0+shft]=2;
   Mvertex_Sph[40*3+0+shft]=2;
   Mvertex_Sph[41*3+0+shft]=2;
   Mvertex_Sph[42*3+0+shft]=3;
   Mvertex_Sph[43*3+0+shft]=3;
   Mvertex_Sph[44*3+0+shft]=3;
   Mvertex_Sph[45*3+0+shft]=2;
   Mvertex_Sph[46*3+0+shft]=1;
   Mvertex_Sph[47*3+0+shft]=1;
   Mvertex_Sph[48*3+0+shft]=2;
   Mvertex_Sph[49*3+0+shft]=2;
   Mvertex_Sph[50*3+0+shft]=2;
   Mvertex_Sph[51*3+0+shft]=1;
   Mvertex_Sph[52*3+0+shft]=1;
   Mvertex_Sph[53*3+0+shft]=2;
   Mvertex_Sph[54*3+0+shft]=1;
   Mvertex_Sph[55*3+0+shft]=1;
   Mvertex_Sph[56*3+0+shft]=1;
   Mvertex_Sph[57*3+0+shft]=1;
   Mvertex_Sph[58*3+0+shft]=2;
   Mvertex_Sph[59*3+0+shft]=2;
   Mvertex_Sph[60*3+0+shft]=1;
   Mvertex_Sph[61*3+0+shft]=1;
   Mvertex_Sph[62*3+0+shft]=1;
   Mvertex_Sph[63*3+0+shft]=1;
   Mvertex_Sph[64*3+0+shft]=2;
   Mvertex_Sph[65*3+0+shft]=2;
   Mvertex_Sph[66*3+0+shft]=2;
   Mvertex_Sph[67*3+0+shft]=2;
   Mvertex_Sph[68*3+0+shft]=2;
   Mvertex_Sph[69*3+0+shft]=1;
   Mvertex_Sph[70*3+0+shft]=1;
   Mvertex_Sph[71*3+0+shft]=1;
   Mvertex_Sph[72*3+0+shft]=1;
   Mvertex_Sph[73*3+0+shft]=1;
   Mvertex_Sph[74*3+0+shft]=1;
   Mvertex_Sph[75*3+0+shft]=2;
   Mvertex_Sph[76*3+0+shft]=0;
   Mvertex_Sph[77*3+0+shft]=1;
   Mvertex_Sph[78*3+0+shft]=1;
   Mvertex_Sph[79*3+0+shft]=1;
   Mvertex_Sph[80*3+0+shft]=1;
   Mvertex_Sph[81*3+0+shft]=0;
   Mvertex_Sph[82*3+0+shft]=1;
   Mvertex_Sph[83*3+0+shft]=0;
   Mvertex_Sph[84*3+0+shft]=1;
   Mvertex_Sph[85*3+0+shft]=1;
   Mvertex_Sph[86*3+0+shft]=1;
   Mvertex_Sph[87*3+0+shft]=0;
   Mvertex_Sph[88*3+0+shft]=1;
   Mvertex_Sph[89*3+0+shft]=1;
   Mvertex_Sph[90*3+0+shft]=0;
   Mvertex_Sph[91*3+0+shft]=1;
   Mvertex_Sph[92*3+0+shft]=1;
   Mvertex_Sph[93*3+0+shft]=2;
   Mvertex_Sph[94*3+0+shft]=1;
   Mvertex_Sph[95*3+0+shft]=1;
   Mvertex_Sph[96*3+0+shft]=1;
   Mvertex_Sph[97*3+0+shft]=1;
   Mvertex_Sph[98*3+0+shft]=0;
   Mvertex_Sph[99*3+0+shft]=1;
   Mvertex_Sph[100*3+0+shft]=0;
   Mvertex_Sph[101*3+0+shft]=1;
   Mvertex_Sph[102*3+0+shft]=1;
   Mvertex_Sph[103*3+0+shft]=0;
   Mvertex_Sph[104*3+0+shft]=1;
   Mvertex_Sph[105*3+0+shft]=1;
   Mvertex_Sph[106*3+0+shft]=1;
   Mvertex_Sph[109*3+0+shft]=1;
   Mvertex_Sph[117*3+0+shft]=1;
   Mvertex_Sph[125*3+0+shft]=1;
   Mvertex_Sph[126*3+0+shft]=1;
   Mvertex_Sph[127*3+0+shft]=1;   
   Mvertex_Sph[142*3+0+shft]=1;  
   /* */
   
   float *ptr_Mvertex_Sph=&Mvertex_Sph[0]; 
   //   ptr_Mvertex_Sph     Mvertex_Sph   

   /* //   !
   //   
   QFile file2("MapSize.map");
   file2.open(QIODevice::ReadOnly);   
   QTextStream in2(&file2);
   in2 >> iteration_max;
   */
     
   int Mtriangle_Sph_size; //  
   
   Mtriangle_Sph_size=5;
   for (int i=0; i<iteration_max; i++)
   {
      Mtriangle_Sph_size=4*Mtriangle_Sph_size; //  
   }

   float Mtriangle_Sph[Mtriangle_Sph_size][3][3]; 
   //   :  ,  ,    
   // //   : 0 - , 1 -  , 2 -                        
   

   int ys1, ys2, xs1, xs2, as1, as2, bs, cs, ds, ks, ps, par1;
   int num1, num2;
      
   // 
   //  
   ys1=0;
   ys2=1;
      
   xs1=0;       
   xs2=0;
   
   //   = as+xs
   as1=0;
   as2=0+1;        
      
   bs=1;
   cs=1; //     
   ks=0; //      
   ds=5;  
      
   par1=0; //             
   ps=0; //   
   
   for (int i=0; i<Mtriangle_Sph_size; i++)
   {           
      if (ps==0) //   
      {
         //  
         num1=as1+xs1;
         xs1++;                        

         num2=as2+xs2;
         xs2++;                       

         // 
         // 0 
         Mtriangle_Sph[i][0][0]=*(ptr_Mvertex_Sph+3*num1+0+shft); //         
         Mtriangle_Sph[i][0][1]=*(ptr_Mvertex_Sph+3*num1+1+shft);
         Mtriangle_Sph[i][0][2]=*(ptr_Mvertex_Sph+3*num1+2+shft);
         
         // 2 
         Mtriangle_Sph[i][2][0]=*(ptr_Mvertex_Sph+3*num2+0+shft);
         Mtriangle_Sph[i][2][1]=*(ptr_Mvertex_Sph+3*num2+1+shft);
         Mtriangle_Sph[i][2][2]=*(ptr_Mvertex_Sph+3*num2+2+shft);
                     
         /* */
            
         //  
         if (xs2==ds) 
         {
            xs2=0;
            par1=1; //     
         }
            
         num1=num2;
         num2=as2+xs2; 
         
         // 
         // 1 
         Mtriangle_Sph[i][1][0]=*(ptr_Mvertex_Sph+3*num2+0+shft);
         Mtriangle_Sph[i][1][1]=*(ptr_Mvertex_Sph+3*num2+1+shft);
         Mtriangle_Sph[i][1][2]=*(ptr_Mvertex_Sph+3*num2+2+shft); 
         
         figure_rendering(i, ps, Mtriangle_Sph); //                   
            
         ks++;                                       
      }
      else //   
      {
         //  
         num1=as2+xs2;
         num2=as1+xs1-1;

         // 
         // 0 
         Mtriangle_Sph[i][0][0]=*(ptr_Mvertex_Sph+3*num1+0+shft); //         
         Mtriangle_Sph[i][0][1]=*(ptr_Mvertex_Sph+3*num1+1+shft);
         Mtriangle_Sph[i][0][2]=*(ptr_Mvertex_Sph+3*num1+2+shft);
         
         // 1 
         Mtriangle_Sph[i][1][0]=*(ptr_Mvertex_Sph+3*num2+0+shft);
         Mtriangle_Sph[i][1][1]=*(ptr_Mvertex_Sph+3*num2+1+shft);
         Mtriangle_Sph[i][1][2]=*(ptr_Mvertex_Sph+3*num2+2+shft);                       
            
         //  
         if (xs1==bs)
         {
            xs1=0;
         } 
            
         num1=num2;            
         num2=as1+xs1;
         
         // 2 
         Mtriangle_Sph[i][2][0]=*(ptr_Mvertex_Sph+3*num2+0+shft);
         Mtriangle_Sph[i][2][1]=*(ptr_Mvertex_Sph+3*num2+1+shft);
         Mtriangle_Sph[i][2][2]=*(ptr_Mvertex_Sph+3*num2+2+shft);
         
         figure_rendering(i, ps, Mtriangle_Sph);         
                     
      }

      if (ps==0) ps=1; else ps=0;
                
      if (ks==cs) //    
      {
         ks=0;
         ps=0;
         xs1--;          
      }                        
         
      if (par1==1) //    
      {
         par1=0;
         ys1++; // 1
         ys2++; // 2
            
         as1=as2;
         as2=as2+ys1*5;
            
         bs=ds;
         ds=ds+5;
            
         xs1=0;
         xs2=0;
            
         ks=0;
         cs++;
      }
         
   }
 
   /* */
 
   glEndList();    

   /* */ 
    
return n; 
} 

//  -
GLfloat Land3D::R_fun(GLint x) 
{
   GLfloat y;
   // 1/pow(4,iteration_max-4) -  ,       
 
   switch(x)
   {
      case 0: y=R; break; // 0 
      case 1: y=R*(1+0.005/pow(4,iteration_max-4)); break; // 100 
      case 2: y=R*(1+0.010/pow(4,iteration_max-4)); break; // 200 
      case 3: y=R*(1+0.020/pow(4,iteration_max-4)); break; // 500 
      case 4: y=R*(1+0.035/pow(4,iteration_max-4)); break; // 1000 
      case 5: y=R*(1+0.050/pow(4,iteration_max-4)); break; // 2000 
      case 6: y=R*(1+0.060/pow(4,iteration_max-4)); break; // 3000 
      case 7: y=R*(1+0.065/pow(4,iteration_max-4)); break; // 4000 
      case 8: y=R*(1+0.070/pow(4,iteration_max-4)); break; // 5000 
      case 9: y=R*(1+0.075/pow(4,iteration_max-4)); break; //  5000  ( 5500 )
      
      default: y=R;       
   }
   return y;
}

/* */

//  -
void Land3D::C_fun(GLint x, GLfloat &color1, GLfloat &color2, GLfloat &color3) 
{
   GLfloat *y1, *y2, *y3;
      
   y1=&color1;
   y2=&color2;
   y3=&color3;
   
   switch(x)
   {
      case 0: *y1=0.5098; *y2=0.7608; *y3=0.9647; break; // 0 
      case 1: *y1=0.3098; *y2=0.9686; *y3=0.5294; break; // 100 
      case 2: *y1=0.6000; *y2=1.0000; *y3=0.6628; break; // 200 
      case 3: *y1=0.9216; *y2=0.8235; *y3=0.5529; break; // 500 
      case 4: *y1=0.8863; *y2=0.6745; *y3=0.3922; break; // 1000 
      case 5: *y1=0.8431; *y2=0.5647; *y3=0.2549; break; // 2000 
      case 6: *y1=0.8392; *y2=0.4980; *y3=0.2902; break; // 3000 
      case 7: *y1=0.8235; *y2=0.4431; *y3=0.2118; break; // 4000 
      case 8: *y1=0.7059; *y2=0.3804; *y3=0.1804; break; // 5000 
      case 9: *y1=0.5843; *y2=0.2863; *y3=0.1529; break; //  5000  ( 5500 )
      
      default: *y1=0; *y2=0; *y3=0;    
   }
}

/* */

//     
void Land3D::figure_rendering(int i, int pp, float M[][3][3]) 
{
   float R0, teta0, phi0, R1, teta1, phi1, R2, teta2, phi2;
   GLfloat xtemp0, ytemp0, ztemp0, xtemp1, ytemp1, ztemp1, xtemp2, ytemp2, ztemp2;    
   
   GLfloat color1, color2, color3; //  ,  Cfun() 
   
   R0=    R_fun(M[i][0][0]);
   teta0=       M[i][0][1];
   phi0=        M[i][0][2];
      
   R1=    R_fun(M[i][1][0]);
   teta1=       M[i][1][1];
   phi1=        M[i][1][2];  
       
   R2=    R_fun(M[i][2][0]);
   teta2=       M[i][2][1];
   phi2=        M[i][2][2];
   
   xtemp0=(R0+eps)*sin(teta0)*sin(phi0);
   ytemp0=(R0+eps)*sin(teta0)*cos(phi0);
   ztemp0=(R0+eps)*cos(teta0);
      
   xtemp1=(R1+eps)*sin(teta1)*sin(phi1);
   ytemp1=(R1+eps)*sin(teta1)*cos(phi1);
   ztemp1=(R1+eps)*cos(teta1);
      
   xtemp2=(R2+eps)*sin(teta2)*sin(phi2);
   ytemp2=(R2+eps)*sin(teta2)*cos(phi2);
   ztemp2=(R2+eps)*cos(teta2);      
   
      
   //  
   glColor4f(0.50f, 0.50f, 0.50f, 1.0f);
           
   if (pp==0)
   {
      glBegin(GL_LINES); // 3 
         glVertex3f( xtemp2, ytemp2 , ztemp2 );
         glVertex3f( xtemp0, ytemp0 , ztemp0 );
      glEnd();       
      glBegin(GL_LINES); // 2 
         glVertex3f( xtemp1, ytemp1 , ztemp1 );
         glVertex3f( xtemp2, ytemp2 , ztemp2 );
      glEnd();   
   }
   else
   {
      glBegin(GL_LINES); // 1 
         glVertex3f( xtemp0, ytemp0 , ztemp0 );
         glVertex3f( xtemp1, ytemp1 , ztemp1 );
      glEnd();  
   }
   
   xtemp0=R0*sin(teta0)*sin(phi0);
   ytemp0=R0*sin(teta0)*cos(phi0);
   ztemp0=R0*cos(teta0);
      
   xtemp1=R1*sin(teta1)*sin(phi1);
   ytemp1=R1*sin(teta1)*cos(phi1);
   ztemp1=R1*cos(teta1);
      
   xtemp2=R2*sin(teta2)*sin(phi2);
   ytemp2=R2*sin(teta2)*cos(phi2);
   ztemp2=R2*cos(teta2);        
      
   //       
   glBegin(GL_TRIANGLES);
      C_fun(M[i][0][0], color1, color2, color3);
      glColor3f(color1, color2, color3);
      glVertex3f( xtemp0, ytemp0 , ztemp0 );
         
      C_fun(M[i][1][0], color1, color2, color3);
      glColor3f(color1, color2, color3);
      glVertex3f( xtemp1, ytemp1 , ztemp1 );
         
      C_fun(M[i][2][0], color1, color2, color3);
      glColor3f(color1, color2, color3);
      glVertex3f( xtemp2, ytemp2 , ztemp2 );
   glEnd();   
}